<?php

/**
 * Plugin Name: Excerpt Shortcode Remover
 * Plugin URI: https://dorset.tech/
 * Description: A super lightweight Plugin to improve the compatibility of page editors such as Visual Composer/WP Page Bakery Builder and Yoast. In Yoast, you can now use the %excerpt% tag in your meta descriptions and this plugin will strip out the shortcodes from the page text before generating the meta description.
 * Version: 1.0
 * Author: Dorset Tech
 * Author URI: https://dorset.tech/
 * License:           GPL v2 or later
 * License URI:       https://www.gnu.org/licenses/gpl-2.0.html
 */

global $plug_version;
$plug_version = '1.0';
global $is_both_active;
$is_both_active = 0;

include_once( ABSPATH . 'wp-admin/includes/plugin.php' );

add_filter( 'wpseo_replacements', 'excerpt_filter_render_shortcode_meta_description', 999);

function excerpt_filter_render_shortcode_meta_description ( $replacements ) {
	global $post, $is_both_active;

	if($is_both_active) {
		if( ! sizeof($replacements) && ! empty($post->post_content) ) {
			//render shortcode first
			$content = do_shortcode( $post->post_content );
			//parse 
			$meta_des = wp_html_excerpt( $content, 155 );
			$replacements['%%excerpt%%'] = $meta_des;
		}
	}

	return $replacements;
}

